import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders } from '@angular/common/http';
import { itemDetail, SearchitemDetailModel } from '../models/itemDetail.model';

@Injectable({ providedIn: 'root' })
export class itemDetailService {

  constructor(private http: HttpClient) { }
  url: string;
  listitemDetail: itemDetail[] = [
    {
      Id : 1,
      equirment : {
        eqId: 2,
        eqName: "เมาส์",
        eqDesc: "...",
        eqType: "it",
        eqPic: "assets/img/mou.jpg"
      },
      userName: 'เกม',
      sDate: '10/12/2560',
      eDate: '10/11/2561',
      sTime: {
        hour: 22,
        minute: 30,
        second: 0
      },
      eTime: {
        hour: 22,
        minute: 30,
        second: 0
      },
      eStatus: 'รอการอนุมัติ',
      Quantity: '1',
      Remark: 'test',
    },
    {
      Id : 2,
      equirment : {
        eqId: 3,
        eqName: "โน๊ตบุ๊ค",
        eqDesc: "หน้าจอขนาด 20 นิ้ว",
        eqType: "it",
        eqPic: "assets/img/notebook.jpg"
      },
      userName: 'แป๊ะ',
      sDate: '',
      eDate: '',
      sTime: {
        hour: 22,
        minute: 30,
        second: 0
      },
      eTime: {
        hour: 22,
        minute: 30,
        second: 0
      },
      eStatus: 'รอการอนุมัติ',
      Quantity: '1',
      Remark: 'test',
    },

  ]

  additemDetail(model: itemDetail) {
    console.log(this.listitemDetail);
    this.listitemDetail.push(model);

  }

  getListitemDetail() {
    return this.listitemDetail;
  }

  // getListitemDetail() {
  //   this.http.get(this.url).subscribe((response: any) => {
  //     console.log(response);
  //     this.listitemDetail = response.content;
  //   }, error => {
  //     console.log(error)
  //     // alert("ไม่สามารถดึงข้อมูลห้องประชุมได้ เนื่องจาก :\n" + error.message)
  //   })
  // }

  searchListitemDetail(searchModel: SearchitemDetailModel) {
    this.http.get(this.url + '&startDate=' + searchModel.sDate.split("-")[2] + '-' + searchModel.sDate.split("-")[1] + '-' + searchModel.sDate.split("-")[0] + '&endDate=' + searchModel.eDate.split("-")[2] + '-' + searchModel.eDate.split("-")[1] + '-' + searchModel.eDate.split("-")[0] + '&startTime=' + searchModel.sTime + ':00' + '&endTime=' + searchModel.eTime + ':00').subscribe((response: any) => {
      console.log(response);
      this.listitemDetail = response;
    }, error => {
      console.log(error)
      alert("ไม่สามารถค้นหาอุปกรณ์ที่ว่างได้ เนื่องจาก :\n" + error.message)
    })
  }

  // addEquirment(EquirmentModel: Equirment) {
  //   this.http.post(this.url, EquirmentModel).subscribe(response => {
  //     console.log(response);

  //   })


  // }
  deleteitemDetail(itemDetailModel: itemDetail) {
    this.http.delete(this.url + "/" + itemDetailModel.Id).subscribe(response => {
      console.log(response);
      this.getListitemDetail()
      alert("ลบข้อมูลอุปกรณ์สำเร็จ")
    })
  }

  updateitemDetail(itemDetailModel: itemDetail) {
    this.http.put(this.url + "/" +itemDetailModel.Id, itemDetailModel).subscribe(response => {
      console.log(response);
      alert("อัพเดทข้อมูลอุปกรณ์สำเร็จ")
    })
  }

  itemDetailModel(eqId: string) {

  }

}